/* Copyright (c) 2000-2006 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

var peTemplateLog = getLoggingMgr().getLogger("peTemplate");

// start the extension
registeredExtensions[registeredExtensions.length] = new peTemplate();

function peTemplate() {
    this.name = 'peTemplate';
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peTemplate.prototype.constructor = peTemplate;

peTemplate.prototype.init = function() {
}

peTemplate.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_openTemplatePart', this);
}

peTemplate.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart_template,'ondblclick',this);
}

peTemplate.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIPart_template,
                                    'Open Template','cmd_openTemplatePart');
}

peTemplate.prototype.supportsCommand = function(command, part) {
    var view = gFocusedProjectView;
    if (!view) return false;
    switch (command) {
    case 'cmd_openTemplatePart':
        return true;
    default:
        break;
    }
    return false;
}

peTemplate.prototype.isCommandEnabled = peTemplate.prototype.supportsCommand

peTemplate.prototype.ondblclick = function(part,event) {
    this.openTemplate(part)
}

peTemplate.prototype.doCommand = function(command) {
    switch (command) {
    case 'cmd_openTemplatePart':
        var items = gFocusedProjectView.getSelectedItems();
        for (var i = 0; i < items.length; i++) {
            if (items[i].type == 'template') this.openTemplate(items[i]);
        }
        break;
    default:
        break;
    }
}

peTemplate.prototype.openTemplate = function(item)
{
    gViewMgr.doFileNewFromTemplate(item.url);
}

function peTemplate_addTemplate(/*koIPart*/ parent)
{
    if (typeof(parent)=='undefined' || !parent)
        parent = gFocusedProjectView.getSelectedItem();

    var filename = filepicker_openFile();
    if (!filename) return;
    var url = uriparse_localPathToURI(filename);
    var templateName = uriparse_baseName(filename);
    var part = parent.project.createPartFromType('template');

    part.setStringAttribute('name', templateName);
    part.url = url;

    gFocusedProjectView.manager.addItem(part,parent);
}

// Add the given template to the toolbox.
//
//  "templateURI" is the URI to the template
//
function AddTemplateToToolbox(templateURI) {
    var part = toolboxMgr.toolbox.createPartFromType('template');
    var name = uriparse_baseName(templateURI);
    var languageRegistry = Components.classes["@activestate.com/koLanguageRegistryService;1"].getService();
    var language = languageRegistry.suggestLanguageForFile(name);
    part.setStringAttribute('name', name);
    part.value = templateURI;

    toolboxMgr.addItem(part);
}

